// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_msgs:srv/DumpGraph.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__DUMP_GRAPH__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__DUMP_GRAPH__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_msgs/srv/detail/dump_graph__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace situational_graphs_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const DumpGraph_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: destination
  {
    out << "destination: ";
    rosidl_generator_traits::value_to_yaml(msg.destination, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DumpGraph_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: destination
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "destination: ";
    rosidl_generator_traits::value_to_yaml(msg.destination, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DumpGraph_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace situational_graphs_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_msgs::srv::DumpGraph_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_msgs::srv::DumpGraph_Request & msg)
{
  return situational_graphs_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_msgs::srv::DumpGraph_Request>()
{
  return "situational_graphs_msgs::srv::DumpGraph_Request";
}

template<>
inline const char * name<situational_graphs_msgs::srv::DumpGraph_Request>()
{
  return "situational_graphs_msgs/srv/DumpGraph_Request";
}

template<>
struct has_fixed_size<situational_graphs_msgs::srv::DumpGraph_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_msgs::srv::DumpGraph_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_msgs::srv::DumpGraph_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace situational_graphs_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const DumpGraph_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DumpGraph_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DumpGraph_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace situational_graphs_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_msgs::srv::DumpGraph_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_msgs::srv::DumpGraph_Response & msg)
{
  return situational_graphs_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_msgs::srv::DumpGraph_Response>()
{
  return "situational_graphs_msgs::srv::DumpGraph_Response";
}

template<>
inline const char * name<situational_graphs_msgs::srv::DumpGraph_Response>()
{
  return "situational_graphs_msgs/srv/DumpGraph_Response";
}

template<>
struct has_fixed_size<situational_graphs_msgs::srv::DumpGraph_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<situational_graphs_msgs::srv::DumpGraph_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<situational_graphs_msgs::srv::DumpGraph_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<situational_graphs_msgs::srv::DumpGraph>()
{
  return "situational_graphs_msgs::srv::DumpGraph";
}

template<>
inline const char * name<situational_graphs_msgs::srv::DumpGraph>()
{
  return "situational_graphs_msgs/srv/DumpGraph";
}

template<>
struct has_fixed_size<situational_graphs_msgs::srv::DumpGraph>
  : std::integral_constant<
    bool,
    has_fixed_size<situational_graphs_msgs::srv::DumpGraph_Request>::value &&
    has_fixed_size<situational_graphs_msgs::srv::DumpGraph_Response>::value
  >
{
};

template<>
struct has_bounded_size<situational_graphs_msgs::srv::DumpGraph>
  : std::integral_constant<
    bool,
    has_bounded_size<situational_graphs_msgs::srv::DumpGraph_Request>::value &&
    has_bounded_size<situational_graphs_msgs::srv::DumpGraph_Response>::value
  >
{
};

template<>
struct is_service<situational_graphs_msgs::srv::DumpGraph>
  : std::true_type
{
};

template<>
struct is_service_request<situational_graphs_msgs::srv::DumpGraph_Request>
  : std::true_type
{
};

template<>
struct is_service_response<situational_graphs_msgs::srv::DumpGraph_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__DUMP_GRAPH__TRAITS_HPP_
